Summary: Generic linux kernel
Name: kernel
Version: 2.0.27
Release: 5
Copyright: GPL
Group: Base/Kernel
ExcludeArch: sparc
ExclusiveOS: Linux
Source: ftp://hyper.stanford.edu/pub/pcmcia/pcmcia-cs-2.8.23.tar.gz
Source1: ftp://ftp.funet.fi/pub/Linux/PEOPLE/Linus/v2.0/linux-2.0.27.tar.gz
Source2: kernel-config.i386
Source3: pcmcia-cs-2.8.8-network.script
Source4: ftp://gear.torque.net/pub/bpcd.c
Source5: module-info
Source6: kernel-config.axp
Source7: http://cesdis.gsfc.nasa.gov/linux/drivers/3c59x.c
Patch: kernel-make.patch
Patch1: pcmcia-cs-2.8.18-config.patch
Patch2: axp-diffs-2.0.27.gz
Patch3: linux-2.0.27-smallncr.patch
Patch4: axp-glibcdiffs-2.0.27.patch
BuildRoot: /tmp/kernel
Provides: module-info
Autoreqprov: no

%package source
Requires: kernel-headers = 2.0.27
Summary: Kernel source tree
Group: Base/Kernel

%package modules
Summary: Collection of kernel modules
Group: Base/Kernel
%ifarch i386
Requires: kernel = 2.0.27
%endif

%package -n pcmcia-cs
Requires: kernel = 2.0.27
Summary: Daemon and device drivers for using PCMCIA adapters
Group: Daemons
Version: 2.8.23

%package headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description modules
This package includes the modules which provide the support for most
supported hardware devices.  The modules are loaded into the running
kernel after it is booted.

%description -n pcmcia-cs
Many laptop machines (and some others) support PCMCIA cards for expansion. 
Also known as "credit card adapters", PCMCIA cards are small cards for
everything from SCSI support to modems. They are hot swappable (they can
be exchanged without rebooting the system) and quite convienent. This package
contains support for numerous PCMCIA cards of all varieties and supplies a
daemon which allows them to be hot swapped.

%description headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
zcat $RPM_SOURCE_DIR/linux-2.0.27.tar.gz | tar -xvf-

find linux -name "*.orig" -print | xargs rm -f
mv linux linux-2.0.27
ln -sfn linux-2.0.27 linux

cd linux-2.0.27

cp -f $RPM_SOURCE_DIR/3c59x.c drivers/net

%patch0 -p1
%patch3 -p1

%ifarch alpha
%patch2 -p1
%patch4 -p1 -b .ewt
find include -name "*.orig" | xargs rm
find include -name "*.ewt" | xargs rm
%endif

%ifarch i386
cp $RPM_SOURCE_DIR/kernel-config.i386 arch/i386/defconfig
%endif
%ifarch alpha
cp $RPM_SOURCE_DIR/kernel-config.axp arch/alpha/defconfig
%endif

# now setup pcmcia stuff back in the build directory
cd $RPM_BUILD_DIR
rm -rf kernel-2.0.27
mkdir kernel-2.0.27
cd kernel-2.0.27
tar xvzf $RPM_SOURCE_DIR/pcmcia-cs-2.8.23.tar.gz
cd pcmcia-cs-2.8.23
%patch1 -p1
touch .prereq.ok
ln -s $RPM_BUILD_ROOT/usr/src/linux-2.0.27 ./kernel-source
ln -s $RPM_BUILD_ROOT ./install-dir

for n in cardmgr debug-tools doc etc flash man modules; do
	cd $n
	ln -s ../kernel-source .
	ln -s ../install-dir .
	cd ..
done

cd ..
mkdir bpcd
cp $RPM_SOURCE_DIR/bpcd.c bpcd

%build
cd $RPM_BUILD_ROOT/usr/src/linux-2.0.27
make oldconfig
make symlinks
make include/linux/version.h

%ifarch i386
# we don't actually build a kernel package on the Alpha
rm -f /usr/include/linux 
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/asm /usr/include/asm
rm -f /usr/include/scsi
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/scsi /usr/include/scsi

make boot
make modules

rm -f /usr/include/linux 
ln -sf ../src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf ../src/linux/include/asm /usr/include/asm
rm -f /usr/include/scsi
ln -sf ../src/linux/include/scsi /usr/include/scsi

cd $RPM_BUILD_DIR/kernel-2.0.27/pcmcia-cs-2.8.23
make all

# now for the backpack CD driver
cd $RPM_BUILD_DIR/kernel-2.0.27/bpcd
gcc -I$RPM_BUILD_ROOT/usr/src/linux/include -D__KERNEL__ -DMODULE -DMODVERSIONS -include $RPM_BUILD_SOOR/usr/src/linux/include/linux/modversions.h -O2 -c bpcd.c
%endif

%install
cd $RPM_BUILD_ROOT/usr/src/linux-2.0.27
mkdir $RPM_BUILD_ROOT/boot
cp $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info

%ifarch i386
cp System.map $RPM_BUILD_ROOT/boot/System.map-2.0.27
cp arch/i386/boot/zImage $RPM_BUILD_ROOT/boot/vmlinuz-2.0.27
ln -sf vmlinuz-2.0.27 $RPM_BUILD_ROOT/boot/vmlinuz
%endif

mkdir -p $RPM_BUILD_ROOT/lib/modules

%ifarch i386
make PREFIX=$RPM_BUILD_ROOT modules_install
cp $RPM_BUILD_DIR/kernel-2.0.27/bpcd/bpcd.o $RPM_BUILD_ROOT/lib/modules/2.0.27/cdrom
%endif

cd $RPM_BUILD_ROOT/usr/src/linux-2.0.27

# keep kernel-source archive clean
make mrproper
make oldconfig
make symlinks
make include/linux/version.h

# this generates modversions info which we want to include and we may as
# well include the depends stuff as well
make depend

# this is dumb :-)
make -C scripts/lxdialog all

%ifarch i386
cd $RPM_BUILD_DIR/kernel-2.0.27/pcmcia-cs-2.8.23
make install

# Install our own network up/down script
install -m755 $RPM_SOURCE_DIR/pcmcia-cs-2.8.8-network.script \
        $RPM_BUILD_ROOT/etc/pcmcia/network

mkdir -p $RPM_BUILD_ROOT/etc/sysconfig

# We need our own default /etc/sysconfig/pcmcia
echo PCMCIA=no > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo PCIC= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia 
echo PCIC_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo CORE_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc6.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d

# We use different default sequence numbers
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K52pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc2.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K52pcmcia

# Finally strip some binaries
cd $RPM_BUILD_ROOT/sbin
strip cardmgr cardctl probe scsi_info ftl_format ftl_check
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
cd /boot
ln -sf vmlinuz-2.0.27 vmlinuz
ln -sf System.map-2.0.27 System.map

if [ -x /sbin/lilo -a -f /etc/lilo.conf ]; then
	/sbin/lilo > /dev/null
fi

%post headers
cd /usr/src
ln -snf linux-2.0.27 linux

%post source
cd /usr/src
ln -snf linux-2.0.27 linux

%postun headers

if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-2.0.27" ]; then
	rm -f /usr/src/linux
    fi
fi

%preun modules
if [ `uname -r` = "2.0.27" ]; then 
	echo "You cannot remove the kernel-modules package for the currently "
	echo "running kernel".
	exit 1
fi

%ifnarch alpha
%files
/boot/vmlinuz-*
/boot/System.map-2.0.27
/boot/module-info
%endif

%files source
%dir /usr/src/linux-2.0.27
/usr/src/linux-2.0.27/COPYING
/usr/src/linux-2.0.27/CREDITS
/usr/src/linux-2.0.27/Documentation
/usr/src/linux-2.0.27/MAINTAINERS
/usr/src/linux-2.0.27/Makefile
/usr/src/linux-2.0.27/Makefile.orig
/usr/src/linux-2.0.27/README
/usr/src/linux-2.0.27/Rules.make
/usr/src/linux-2.0.27/arch
/usr/src/linux-2.0.27/drivers
/usr/src/linux-2.0.27/fs
/usr/src/linux-2.0.27/init
/usr/src/linux-2.0.27/ipc
/usr/src/linux-2.0.27/kernel
/usr/src/linux-2.0.27/lib
/usr/src/linux-2.0.27/mm
/usr/src/linux-2.0.27/modules
/usr/src/linux-2.0.27/net
/usr/src/linux-2.0.27/scripts

%ifnarch alpha
%files modules
%ifarch i386
# intel rules
%dir /lib/modules
%dir /lib/modules/2.0.27
/lib/modules/2.0.27/scsi
/lib/modules/2.0.27/net
/lib/modules/2.0.27/block
/lib/modules/2.0.27/cdrom
/lib/modules/2.0.27/fs
/lib/modules/2.0.27/misc
/lib/modules/2.0.27/ipv4
%else
# SPARC (though we don't build a sparc frmo this spec file yet)
/lib/modules
%endif
%endif

%ifarch i386
%files -n pcmcia-cs
%doc kernel-2.0.27/pcmcia-cs-2.8.23/doc/PCMCIA-HOWTO 
%doc kernel-2.0.27/pcmcia-cs-2.8.23/SUPPORTED.CARDS 
%doc kernel-2.0.27/pcmcia-cs-2.8.23/CHANGES 
%doc kernel-2.0.27/pcmcia-cs-2.8.23/COPYING 
%doc kernel-2.0.27/pcmcia-cs-2.8.23/README
/lib/modules/2.0.27/pcmcia

/sbin/cardmgr
/sbin/cardctl
/sbin/probe
/sbin/scsi_info

/sbin/ftl_format
/sbin/ftl_check

/usr/man/man1/cardinfo.1

/usr/man/man8/cardmgr.8
/usr/man/man8/cardctl.8
/usr/man/man8/ftl_format.8
/usr/man/man8/ftl_check.8
/usr/man/man8/scsi_info.8

/usr/man/man5/pcmcia.5
/usr/man/man5/stab.5

/usr/man/man4/pcmcia_core.4
/usr/man/man4/tcic.4
/usr/man/man4/i82365.4
/usr/man/man4/tc589_cs.4
/usr/man/man4/pcnet_cs.4
/usr/man/man4/serial_cs.4
/usr/man/man4/pcmem_cs.4
/usr/man/man4/ftl_cs.4
/usr/man/man4/memory_cs.4

/etc/rc.d/rc0.d/K52pcmcia
/etc/rc.d/rc2.d/S45pcmcia
/etc/rc.d/rc3.d/S45pcmcia
/etc/rc.d/rc5.d/S45pcmcia
/etc/rc.d/rc6.d/K52pcmcia

%config /etc/rc.d/init.d/pcmcia
%config /etc/sysconfig/pcmcia
%dir /etc/pcmcia
/etc/pcmcia/config
/etc/pcmcia/fixed
/etc/pcmcia/ftl
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/pcmem
/etc/pcmcia/scsi
/etc/pcmcia/serial

%config /etc/pcmcia/config.opts
%config /etc/pcmcia/fixed.opts
%config /etc/pcmcia/ftl.opts
%config /etc/pcmcia/memory.opts
%config /etc/pcmcia/pcmem.opts
%config /etc/pcmcia/scsi.opts
%config /etc/pcmcia/serial.opts
%endif

%files headers
/usr/src/linux-2.0.27/include/asm
/usr/src/linux-2.0.27/include/asm-generic
/usr/src/linux-2.0.27/include/linux
/usr/src/linux-2.0.27/include/net
/usr/src/linux-2.0.27/include/scsi

%ifarch alpha
/usr/src/linux-2.0.27/include/asm-alpha
%endif

%ifarch i386
/usr/src/linux-2.0.27/include/asm-i386
%endif
